use Test::More tests => 6;

#########################

my $bp = 'blib/script/blog_post';

if( -e "remove_this" ) {
    die "Test directory 'remove_this' exists. Please remove and run tests again.\n";
}
system('mkdir', 'remove_this');


##
## test: happy test
##
open my $t, "|$bp -c -h . -r /remove_this"
  or die "Could not write to pipe: $!\n";
print $t <<_TEST_;
## Nice Title
## /tests/nice_title.txt
This is the body of the post. Have a nice day.
_TEST_
close $t;

ok( -f 'remove_this/tests/nice_title.txt', "blog created" );
my $grok = `grep 'body of the post' remove_this/tests/nice_title.txt`;
like( $grok, qr(body of the post), "blog entry ok" );


##
## test: test subject on command-line
##
undef $t;
open $t, "|$bp -c -h . -r /remove_this -t 'This is my topic'"
  or die "Could not write to pipe: $!\n";
print $t <<_TEST_;
## /tests/blarney/nice_title.txt
This is the body of the foo post. Have a nice day.
_TEST_
close $t;

ok( -f 'remove_this/tests/blarney/nice_title.txt', "deeper blog created" );
is( `head -n 1 remove_this/tests/blarney/nice_title.txt`, "This is my topic\n", "title ok" );
$grok = `grep 'body of the foo post' remove_this/tests/blarney/nice_title.txt`;
like( $grok, qr(body of the foo post), "blog entry ok (subject on command-line)" );


##
## test: try to break through security
##
undef $t;
open $t, "|$bp -c -h . -r /remove_this -t 'This is my topic'"
  or die "Could not write to pipe: $!\n";
print $t <<_TEST_;
## /tests/.././../blanket/nice_hack.txt
This is the body of the foo post. Have a nice day.
_TEST_
close $t;

ok( ! -d 'blanket', "target directory not created" );


END {
    system('rm', '-r', 'remove_this');
}
